package org.swtchart.data;

import java.util.Vector;

import org.swtchart.util.DateUtil;


/**
 *  Ŭ time-chart  ü̴.<br>
 * @version	2006.05.17
 * @author 	Sang-woog Kim
 */
public class TimeChartData {

	private Vector data = new Vector();
	
	private String dateFormat = "hh:mm:ss";
	
	private int maxSize = 0;
	
	private String title = "Title";
	
	/**
	 *  Ŭ ⺻ ̴.<br>
	 */
	public TimeChartData() {}
	
	/**
	 * ִũ⸦ ϴ Դϴ.<br>
	 * ִũ⸦ ϸ  ̻ Ͱ      ˴ϴ.<br>
	 * @param maxSize
	 */
	public TimeChartData(int maxSize) {
		this.maxSize = maxSize;
	}
	
	/**
	 *  ߰Ѵ.<br>
	 * @param value		߰ 
	 */
	public void add(double value) {
		String item = getCurrentDateTime();
		data.add(new Data(item, value));
		checkMaxSize();
	}
	
	/**
	 *  ε  ߰Ѵ.<br>
	 * @param index	 ε
	 * @param value	߰ 
	 */
	public void add(int index, double value) {
		String item = getCurrentDateTime();
		data.add(index, new Data(item, value));
		checkMaxSize();
	}
	
	/**
	 *  ġ Dataü Ѵ.<br>
	 * @param index		 ġ
	 * @return			Dataü
	 */
	public Data get(int index) {
		return (Data)data.get(index);
	}
	
	/**
	 * Vector ߰ Dataü  Ѵ.<br>
	 * @return	Dataü  .
	 */
	public int size() {
		return data.size();
	}
	
	/**
	 * Data format ڿ ´.<br>
	 * @return		Data format ڿ .
	 */
	public String getDateFormat() {
		return dateFormat;
	}

	/**
	 * Data format ڿ Ѵ.<br>
	 * @param dateFormat	Data format ڿ
	 */
	public void setDateFormat(String dateFormat) {
		this.dateFormat = dateFormat;
	}
	
	/**
	 * ȭ鿡   ´.
	 * @return	ȭ鿡  
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * ȭ鿡   Ѵ.
	 * @param title	ȭ鿡  
	 */
	public void setTitle(String title) {
		this.title = title;
	}

	private String getCurrentDateTime() {
		return DateUtil.getCurrentDate(dateFormat);
	}

	private void checkMaxSize() {
		if ( maxSize == 0 ) return;
		while ( data.size() > maxSize ) {
			data.remove(0);
		}
	}
}
